<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    <style>
        table,
        th,
        td {
            border: 1px solid black;
        }
        
        .form {
            margin: auto;
            width: 50%;
            padding: 10px;
            height: 480px;
        }
    </style>
</head>

<body>
    <div id="app">

        <div class="form">
            <div class="text-center">
                <h2>Tugas Ajax</h2>
            </div>
            <div class="mb-3">
                <label class="form-label">Nama</label>
                <input type="text" class="form-control" v-model="form.nama" :disabled="editForm == 'upload'">
            </div>
            <div class="mb-3">
                <label class="form-label">Alamat</label>
                <input type="text" class="form-control" v-model="form.alamat" :disabled="editForm == 'upload'">
            </div>
            <div class="mb-3">
                <label class="form-label">No HP</label>
                <input type="number" class="form-control" v-model="form.nohp" :disabled="editForm == 'upload'">
            </div>


            <div class="d-grid gap-2 " v-if="editForm=='submit' ">
                <button class="btn btn-success " type="submit " v-on:click="createdUser()">Submit</button>
            </div>
            <div class="d-grid gap-2 " v-else-if="editForm=='update' ">
                <button class="btn btn-success " type="submit " v-on:click="updateUser(form.id) ">Update</button>
                <button class="btn btn-secondary " type="button " v-on:click="cancelButtomUser() ">Cancel</button>
            </div>
            <div class="d-grid gap-2 " v-else-if="editForm=='upload' ">
                <div class="mb-3" v-if="editForm == 'upload'">
                    <label class="form-label">Gambar</label>
                    <!-- <input type="file" id="file" ref="file" v-on:change="handleFileUpload()" /> -->
                    <input class="form-control" type="file" id="file" ref="file">
                </div>
                <button class="btn btn-success " type="button" v-on:click="uploadFile(form.id)">Upload File</button>
                <button class="btn btn-secondary " type="button " v-on:click="cancelButtomUser() ">Cancel</button>
            </div>
        </div>

        <hr>
        <div class="container ">
            <div v-if="loading " class="text-center " colspan="5 ">
                <infinite-loading spinner="circles"></infinite-loading>
            </div>
            <table class="table " v-else>
                <thead class="text-center ">
                    <tr>
                        <th>Gambar</th>
                        <th>Nama</th>
                        <th>Alamat</th>
                        <th>No HP</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item, index) in user ">
                        <td class="text-center "><img :src="item.photo_profile ? domain + item.photo_profile : defaultGambar " width="200px " alt=" "></td>
                        <td>{{ item.name}}</td>
                        <td>{{ item.address}}</td>
                        <td>{{ item.no_hp}}</td>
                        <td class="text-center ">
                            <button class="btn btn-primary btn-sm " v-on:click="editButtomUser(item.id, item.name, item.address, item.no_hp, index) ">Edit</button>
                            <button class="btn btn-danger btn-sm " v-on:click="deleteUser(item.id) ">Delete</button>
                            <button class="btn btn-success btn-sm " v-on:click="uploadButtomUser(item.id, item.name, item.address, item.no_hp, index) ">Upload File</button>
                        </td>
                    </tr>

                </tbody>
            </table>


        </div>

    </div>



    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js "></script>
    <script src="https://unpkg.com/vue-infinite-loading@^2/dist/vue-infinite-loading.js "></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js "></script>
    <script>
        const api = '//hn.algolia.com/api/v1/search_by_date?tags=story';
        var vm = new Vue({
            el: '#app',
            data: {
                loading: false,
                editForm: 'submit',
                domain: 'https://demo-api-vue.sanbercloud.com/',
                defaultGambar: 'https://dummyimage.com/16:9x1080',
                form: [
                    index => '',
                    nama => '',
                    id => '',
                    alamat => '',
                    gambar => '',
                    nohp => ''
                ],
                nama: '',
                index: '',
                user: [],
            },
            computed: {},
            methods: {
                clearForm: function() {
                    this.editForm = "submit "
                    this.form.index = ''
                    this.form.id = ''
                    this.form.nama = ''
                    this.form.alamat = ''
                    this.form.nohp = ''
                },
                getUser: function() {
                    this.loading = true
                    const config = {
                        methods: "get ",
                        url: 'http://demo-api-vue.sanbercloud.com/api/member'
                    }
                    axios(config)
                        .then((response) => {
                            this.user = response.data.members
                            console.log(response.data.members)
                            this.loading = false
                        })
                        .catch((error) => {
                            console.log(error);
                        })

                },

                createdUser: function() {
                    let formData = new FormData()
                    formData.append('name', this.form.nama)
                    formData.append('address', this.form.alamat)
                    formData.append('no_hp', this.form.nohp)
                    const config = {
                        method: "POST",
                        url: 'http://demo-api-vue.sanbercloud.com/api/member',
                        data: formData
                    }
                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getUser()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            alert(error)
                        })
                },

                updateUser: function(id) {
                    let formData = new FormData()
                    formData.append('name', this.form.nama)
                    formData.append('address', this.form.alamat)
                    formData.append('no_hp', this.form.nohp)
                    const config = {
                        method: "POST",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: {
                            _method: "PUT "
                        },
                        data: formData
                    }
                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getUser()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            alert(error)
                        })
                },

                deleteUser: function(id) {
                    const config = {
                        method: "POST",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: {
                            _method: "DELETE "
                        }
                    }
                    axios(config)
                        .then((response) => {
                            this.getUser()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            alert(error)
                        })
                },

                uploadFile: function(id) {
                    let file = this.$refs.file.files[0]

                    let formData = new FormData()
                    formData.append('photo_profile', file)

                    const config = {
                        method: "POST",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }
                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getUser()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            alert(error)
                        })
                },




                editButtomUser: function(id, nama, alamat, nohp, index) {
                    this.editForm = 'update'
                    this.form.index = index
                    this.form.id = id
                    this.form.nama = nama
                    this.form.alamat = alamat
                    this.form.nohp = nohp
                },
                uploadButtomUser: function(id, nama, alamat, nohp, index) {
                    this.editForm = 'upload'
                    this.form.index = index
                    this.form.id = id
                    this.form.nama = nama
                    this.form.alamat = alamat
                    this.form.nohp = nohp
                },
                cancelButtomUser: function() {
                    this.editForm = 'submit'
                    this.form.index = ''
                    this.form.id = ''
                    this.form.nama = ''
                    this.form.alamat = ''
                    this.form.nohp = ''
                },


            },
            created() {
                this.getUser()
            },
        })
    </script>

</body>

</html>